// Disable caching of AJAX responses
$jq.ajaxSetup ({
    cache: false
});

//Pad function
$jq.strPad = function(i,l,s) {
	var o = i.toString();
	if (!s) { s = '0'; }
	while (o.length < l) {
		o = o + s;
	}
	return o;
};

//Numeric check
function IsNumeric(sText){

	var ValidChars = "0123456789.";
	var IsNumber=true;
	var Char;

	for (i = 0; i < sText.length && IsNumber == true; i++){ 
		Char = sText.charAt(i); 
		if(ValidChars.indexOf(Char) == -1){
			IsNumber = false;
		}
	}

	return IsNumber; 
}

//Display a notification
function hs_msg(msg,sticky,classname){
	sticky = sticky || false;
	classname = classname || false;
	
	if(classname) $("hs_msg").addClassName(classname);
	
	var space = 20;
	//Set body of message, use sizer span to get exact width
	$("hs_msg").update(msg);
	
	//Center
	var w = innerWinSize();
	var toppos = (w.height - 41) + "px";
	$("hs_msg").setStyle({top: toppos}); //26px high box plus 10 padding plus 5 space at bottom
	
	//Show
	new Effect.Parallel([
		new Effect.Move("hs_msg", { sync: true, x: 0, y: -30, mode: 'relative' }),
		new Effect.Appear("hs_msg", { sync: true })
	], { 
	  duration: 0.8
	});
	//Hide
	if(!sticky){
		setTimeout(function(){
			Effect.Fade('hs_msg', { duration: 1.0, onComplete: function(){
				//Reset position as effect moves it
				$("hs_msg").setStyle({top: toppos});
				//Reset class
				if(classname) $("hs_msg").removeClassName(classname);
			} });
		},3000);
	}
}

//Submit the login form
function login_form_sub(){
	new Ajax.Request("admin.php?pg=ajax_gateway&action=logincheck", 
		{method:"post", 
		 parameters: {username:$F("popup_username"), password:$F("popup_password")},
		 onSuccess: function(){
		 	Tips.hideAll();
		 	$jq.colorbox.close();
		 	did_re_login = true;
		 }
		}
	);
	return false;
}

//Preload images
function preloadImages(){
  var cache = [];
  // Arguments are image paths relative to the current page.
    var args_len = arguments.length;
    for (var i = args_len; i--;) {
      var cacheImage = document.createElement('img');
      cacheImage.src = arguments[i];
      cache.push(cacheImage);
    }
}

//Is a var defined
function hs_isdefined(variable)
{
    return (typeof(window[variable]) == "undefined")?  false: true;
}

function is_wysiwyg(){
	return ( !(typeof(textboxio) == "undefined") && textboxio.getActiveEditor() !== null );
}

function focus_note_body(field){
	if(! is_wysiwyg()){
		Field.focus(field);
	}
}

function get_note_body(field){
	if(is_wysiwyg()){
		var $html = $jq('#ephox_wysiwyg_input .ephox-hare-content-iframe').contents().find('body').html();
		if ($html) {
			// This is a fix for inline images so they end with a new line.
			// $html = $html.replace(/\)##/g, ")##\n\r");
			$html = $html.replace(/<\/(div|p|br)>/g, "\n<\/$1>\n");
			$html = $html.replace(/<(div|p|br)>/g, "\n<\$1>\n");
		} else {
			// We have no data... Maybe it's in code view?
			$html = textboxio.getActiveEditor().content.get();
		}

		// use jquery to see if it's empty. By default textbox has html tags that causes it not be blank.
		return ($jq("<div/>").html($html).text().trim() != "") ? $html : "";
		// return ($jq("<div/>").html(textboxio.getActiveEditor().content.get()).text().trim() != "") ? textboxio.getActiveEditor().content.get() : "";
	}else{
		return ($F(field) ? $F(field) : "");
	}
}

function set_note_body(field,content){
	if(is_wysiwyg()){
		return textboxio.getActiveEditor().content.set(content)
	}else{
		return $(field).value = content;
	}
}

function append_wysiwyg_note_body(field, content)
{
	return textboxio.getActiveEditor().content.set(get_note_body(field) + content)
}

// send to page
function goPage(src){
	window.location.href = src;	
}

//By using idle timers we prevent periodically executed events from barraging a server when the user is
//not actually using the system. This is especially helpful with users who use multiple browser tabs.
//Note, can't use window blur/focus due to wysiwyg & other irregularities
function hs_PeriodicalExecuter(name,user_function,timeout){
	//Global variable name
	var varname = 'helpspot_pe_' + name;

    // Run the function every 300 seconds
	window[varname] = setInterval(user_function, timeout * 1000);
	
	$jq(document).bind("idle.idleTimer", function(){
		clearInterval(window[varname]);
	});
	
	$jq(document).bind("active.idleTimer", function(){
		user_function(); //Cause actions to occur as soon as back active for responsiveness
		window[varname] = setInterval(user_function, timeout * 1000);
	});

	//If idle for 180 seconds then stop execution
	$jq.idleTimer(cHD_IDLE_TIMEOUT * 1000);
}

//Alert box
function hs_alert(txt,options){
	var options = Object.extend({
	  errorlist:	true,
	  title: 		lg_js_notification
	}, arguments[1] || { });
	var body = "";
	
	if(options.errorlist){
		var list = txt.split(/(\r\n|[\r\n])/);
		body = '<ul class="alert-error-list">';
		for(i=0;i<list.length;i++){
			if(trim(list[i]) != "") body = body + '<li>'+list[i]+'</li>';
		}
		body = body + '</ul>';
	}else{
		body = txt.replace(/(\r\n|[\r\n])/g, "<br />");
	}

	$jq.colorbox({width: "500px",
				  opacity: 0.40, 
				  transition: 'none',
				  close: button_ok,
				  html: '<div class="alert-body">'+ body + '</div>' + '<div class="alert-title">'+options.title+'</div>',
				  onComplete: function(){
				  		$jq("#alert-button-ok").focus();
				  	}
				  });	
}

//Confirm box
function hs_confirm(txt,action,options){
	var options = Object.extend({
	  title: 		lg_js_confirmation
	}, arguments[1] || { });
	
	$jq.colorbox({width: "500px",
				  opacity: 0.40, 
				  transition: 'none',
				  close: button_cancel,
				  html: '<div class="alert-confirm-body">'+ txt + '</div>' + '<div class="alert-title">'+options.title+'</div>' + '<div class="alert-button-group">'+ button_ok +'</div>',
				  onComplete: function(){
				  	//Execute function or else go to URL
				  	if($jq.type(action) === "function"){
				  		$jq("#alert-button-ok").click(action);
				  	}else{
				  		$jq("#alert-button-ok").click(function(){goPage(action);});
				  	}
				  	
				  	//Add closing action
				  	$jq("#alert-button-ok").click(function(){
				  		$jq.colorbox.close();
				  	});
				  	
				  	//Focus
				  	$jq("#alert-button-ok").focus();
				  }
				  });	
				  
	return false;			  
}

function kbui(bookid){
	$jq.colorbox({width: "90%",
				  fixed: true,
				  height: "90%",
				  opacity: 0.80, 
				  close: button_close,
				  href: "admin.php?pg=ajax_gateway&action=kbui&xBook=" + bookid + "&rand=" + ajaxRandomString(),
				  onComplete: function(){
				  	kbui_gettoc(bookid);
				  }
				  });	
}

function kbui_showpage(pageid){
	$jq("#kbui-page").html(ajaxLoading());
	$jq("#kbui-page").load("admin.php?pg=ajax_gateway&action=kbui-page&xPage="+pageid+"&xPortal="+$jq("#xPortal").val());
}

function kbui_gettoc(bookid){
	$jq("#kbui-toc").load("admin.php?pg=ajax_gateway&action=kbui-toc&xBook="+bookid, function(){
		folderUI("kbui-toc");
		$jq("#kbui-toc .kbui:first").click(); //load first page in this toc
	});
}

function aKBL(link,text){
	//If the tPost box exists in forums use that
	if($jq("#tPost").length){
		var elem = "tPost";
		var docpath = document.postform.tPost;
	}else{
		var elem = "tBody";
		var docpath = document.requestform.tBody;	
	}

	if(elem == 'tBody' && editor_type == "wysiwyg" && is_wysiwyg("tBody")){
		// tinyMCE.execInstanceCommand(elem,"mceInsertContent",false,"<a href=\""+link+"\">"+text+"</a>");
		textboxio.getActiveEditor().content.insertHtmlAtCursor("<a href=\""+link+"\">"+text+"</a>");
	}else if(elem == 'tBody' && editor_type == "markdown"){
		insertAtCursor(docpath, "["+text+"]("+link+")");
	}else{		
		insertAtCursor(docpath, link);
	}

	$jq.colorbox.close();

	return false;
}

function folderUI(wrap){
	//Init array of open folders
	var sidebarOpenFolders = (getCookie("sidebarOpenFolders") ? getCookie("sidebarOpenFolders").split(",") : []);	

	//Click handler for folders
	$$("#" + wrap + " .folder").each(function(folder){
		$(folder).observe("click", function(event){
			Event.stop(event);
			$$("."+this.id).each(function(elem){
				elem.toggle();
			});
			$$("#"+this.id+" span.arrow").each(function(elem){
				elem.toggleClassName("arrow-open");
			});
			
			//Remember state
			var loc = indexInArray(sidebarOpenFolders, this.id);
			if(loc == -1){
				sidebarOpenFolders.push(this.id);
			}else{
				sidebarOpenFolders.splice(loc, 1);
			}
			
			//Save state cookie
			var cdate = new Date ( 2020, 1, 1 );
			setCookie("sidebarOpenFolders", sidebarOpenFolders.join(","), cdate);
		});
	});
}

//Get the url hash
function getHash(){
  var hash = window.location.hash;
  return hash.substring(1); //remove the #
}

//Open new page in original win from popup
function targetopener(mylink, closeme, closeonly){
	if (! (window.focus && window.opener))return true;
	window.opener.focus();
	if (! closeonly)window.opener.location.href=mylink.href;
	if (closeme)window.close();
	return false;
}

//Open a window
//ex: <a href="javascript:openWin(\'admin.php?pg=user.image\',\'ImagePick\',\'height=500, width=500, scrollbars=yes, toolbar=no, location=no, status=yes\');">
function openWin(loc,name,options){
	window.open(loc, "", options);
}

function showPopWin(page,winh,winw,name){
	openWin(page,name,'height='+winh+',width='+winw+',scrollbars=yes,toolbar=no,location=no,status=no,resizable=yes');
}

//close window with delay 
function hsCloseWin(time){
	if(!time){
		time = 2;
	}
	
	setTimeout("window.close()",time*1000);
}

//sets times when using quick time select function
function qtSet(id,from,to){
	times = Form.Element.getValue(id);
	if(times != ""){
		v = Form.Element.getValue(id).split("|");
		$(from).value = v[0];
		$('from_da').update(v[1]);
		$(to).value = v[2];
		$('to_da').update(v[3]);
		if(v[4]){
			//Only override grouping if it's currently a date type (and not a date agg type)
			if($jq("#graph_grouping").val().search("date_") != -1 && $jq("#graph_grouping").val().search("date_agg") == -1) setSelectToValue("graph_grouping",v[4]);
		}
	}
}

//js sidebar search
function sidebarReqSearch(evt){
	evt.keyCode == 13 ? sidebarSearchAction("request") : evt;
}

function sidebarSearchAction(type){
	if(type == "request"){
		var q = trim($jq("#sidebar-q").val());
        var doFullText = ($jq("#doFullTextSearch").get(0).checked) ? 1 : 0;
		
		//If just a number, use as reqid else search
		if(IsNumeric(q)){
			goPage("admin.php?pg=request&reqid=" + q);
		}else{
			//Handle different search types
			var name = q.split(" ");
			if(q.search(/@/) > 0){
				var url = "admin.php?pg=ajax_gateway&action=sidebarsearch&doFullText="+eq(doFullText)+"&search_type=2&q="+eq(q)+"&anyall=all&sEmail="+eq(q)+"&rand="+ajaxRandomString();
			}else if(name.length > 1){ 
				var url = "admin.php?pg=ajax_gateway&action=sidebarsearch&doFullText="+eq(doFullText)+"&search_type=3&q="+eq(q)+"&anyall=all&sFirstName="+eq(name[0])+"&sLastName="+eq(name[1])+"&rand="+ajaxRandomString();
			}else{
				var url = "admin.php?pg=ajax_gateway&action=sidebarsearch&doFullText="+eq(doFullText)+"&search_type=1&q="+eq(q)+"&anyall=any&sUserId="+eq(q)+"&sFirstName="+eq(q)+"&sLastName="+eq(q)+"&sEmail="+eq(q)+"&rand="+ajaxRandomString();
			}
			
			hs_overlay({width:'90%',href:url});
		}
	}
}

//shortcut flag
var shortcutsON = true;

function hs_shortcutsOff(){
	shortcutsON = false;
}

function hs_shortcutsOn(){
	shortcutsON = true;
}
	
//Set Cookie
function setCookie(name,value,expires,path,domain,secure) {
    var cookieString = name + "=" +escape(value) +
       ( (expires) ? ";expires=" + expires.toGMTString() : "") +
       ( (path) ? ";path=" + path : "") +
       ( (domain) ? ";domain=" + domain : "") +
       ( (secure) ? ";secure" : "");
    document.cookie = cookieString;
} 

//Get Cookie
function getCookie(cookie_name) {
		var str     = document.cookie;
        var cookies = str.split(';');
        for (var i = cookies.length; i--;)
        {
          var parts = cookies[i].split('=');
          if (parts[0].substring(0,1) == ' ')
              parts[0] = parts[0].substring(1,parts[0].length);

          if (unescape(parts[0]) == cookie_name){
             return unescape(parts[1]);
             }
        }
        return '';
}    

//Trim extra whitespace
function trim(stringToTrim) {
	return $jq.trim(stringToTrim);
	//return stringToTrim.replace(/^\s+|\s+$/g,"");
}

//Set focus to field
function setFieldFocus(fld){
	if(fld){
		fld.focus();
	}
}

//Clear the filler text in a form element
function clearFocusFill(obj,text,newclass){
	if(obj.value == text) obj.value = "";
	if(newclass) Element.addClassName(obj.id,newclass);
}

//Checkbox row highlight
function checkRowHighlight(rid){
	if(document.getElementById(rid+"_box")){
		if(document.getElementById(rid+"_box").checked){
			document.getElementById(rid).className = "boldcheckboxrow";
		}else{
			document.getElementById(rid).className = "";
		}			
	}
}

//Loop over checkbox sets and make lines bold. use with above.
function onloadRowHighlight(pre,len)
{
	for(var i=0; i<len; i++){
		checkRowHighlight(pre + i);
	}
}	

// Check any rows that are already checked. See #364
function checkRows() {
  $jq.each($jq(".checkbox-menu").find("input:checked"), function() {
    rowChecked(this.value);
  });
}
//Highlight a table row
function rowChecked(reqid){
	row = $("tr-"+reqid);
	box = $(reqid + "_checkbox");
	
	if(box.checked){
		Element.addClassName(box,"checkedfilterrow");
		Element.addClassName(row,"checkedfilterrow");				
	}else{
		Element.removeClassName(box,"checkedfilterrow");
		Element.removeClassName(row,"checkedfilterrow");
	}	
	
	//Make sure any hidden buttons are shown
	$("batch_action_buttons").removeClassName("thin-disabled");
}

//Sort ordering
function reorder_call(id,type){
	var url = "admin.php";
	var pars = "pg=ajax_gateway&action="+type+"&" + Sortable.serialize(id,{name:"sortorder"}) + "&rand=" + ajaxRandomString();
	
	var call = new Ajax.Request(
		url, 
		{
			method: 	 "get", 
			parameters:  pars, 
			onComplete:  function(){ $$("#tablesort .sortable").each(function(elem){ new Effect.Highlight(elem,{duration:1.0,startcolor:"#DCE8D8",keepBackgroundImage:true}); }); }
		});			
}

//Given a value go through a form and find the ID
//Fields is an array for form elements (usually) from Form.getInputs("rsform_1", "checkbox");
function findIDbyValue(fields,value){
	for(i=0;i < fields.length;i++){
		if(fields[i].value == value) return fields[i].id;
	}
}

//Find the currently checked value in a radio button group
function getCheckedRadioButton(buttonGroup){
	for(var i = 0; i < buttonGroup.length; i++){
		if(buttonGroup[i].checked){
			return i;	
		}
	}
}

//Find the currently selected option
function getSelectVal(elem){
	return $(elem).options[$(elem).selectedIndex].value;
}

// Return the index of a particular value
function hs_indexOf(thearray,item) {
    for (var i = 0; i < thearray.length; i++) {
        if (thearray[i] == item) {
            return i;
        }
    }
    return -1;
}

// Return true if the value is in an array
function hs_inArray (value)
// Returns true if the passed value is found in the
// array.  Returns false if it is not.
{
	var i;
	for (i=0; i < this.length; i++) {
		// Matches identical (===), not just similar (==).
		if (this[i] === value) {
			return true;
		}
	}
	return false;
};

//Find index in an array
function indexInArray(theArray, theValue){
	var arLength = theArray.length;

	for(var i=0; i < arLength; i++){
		if(theArray[i] == theValue){
			return i;
		}
	}

	return -1;
}

// Add ability to pad a string
function hs_pad(str, chr, num, prepend) {
  for (var i=str.length; i<num; i++) {
    str = ((prepend) ? (chr + str) : (str + chr));
  }
  return str;
}

// Use this function in textbox to prevent enter from submitting the form, optionally do a click event
function noenter(e, click_elem) {
	if (!e) var e = window.event
	if (e.keyCode) code = e.keyCode;
	else if (e.which) code = e.which;
	
	if(click_elem){
		if(code == 13){ 
			$(click_elem).onclick();
			return false;
		}else{
			return true;
		}
	}else{
		return !(code == 13); 
	}
}

//Set a select list to a value if the value exists
function setSelectToValue(selectname,v,reset){
	list = $(selectname).options;
	
	if(typeof(reset) != 'undefined') list.selectedIndex = 0;
	
	if(list && v){
		for(i=0; i < list.length; i++){
			if(list[i].value == v){
				list.selectedIndex = i;
				break;
			}
		}
	}
}

//Set a select list to a value if the text exists
function setSelectByText(selectname,v){
	list = $(selectname).options;
	
	if(list && v){
		for(i=0; i < list.length; i++){
			if(list[i].text == v){
				list.selectedIndex = i;
				break;
			}
		}
	}
}

function help_toggle(page,from){
	var from = (from ? from : "");
	new Ajax.Updater('help_toggle_body', "admin.php?pg=ajax_gateway&action=help&page="+page+"&from="+from+"&rand=" + ajaxRandomString());	
}

// CHECK RECORDSET ALL
function checkUncheckRsAll(id) {
	
	$$("input[name^=checktable]").each(function(elem){
		$(elem).checked = $(elem).checked ? false : true;
		$(elem).onclick();
	});
			
	return true;
}

// END CHECK ALL

//CHECK ONLY A GROUP OF REQUESTS
function checkUncheckRequestGroup(grouping){
	var boxes = $$('input.'+grouping);
	if($('groupcheckbox_'+grouping).checked){
		boxes.each(function(box){
			if(box.checked == false) box.click();
		});
	}else{
		boxes.each(function(box){
			if(box.checked == true) box.click();
		});	
	}	
}

//Create the stream view
streamViewCurrent = 0;
function streamViewInit(reqid, mode){
	streamViewCurrent = reqid;
	
	$("streamViewBody").update("<div class='streamview_loading'><img src='"+static_path+"/css/shared/general/big-loader.gif' /></div>");
	$("streamViewTop_reqid").update("");
	
	$jq.colorbox({
    width: "90%",
    height: "90%",
    opacity: 0.80,
    close: button_close,
    html: $jq("#streamView").html(),
    onLoad:function(){
      $jq("#cboxClose").hide();
    }
	});

  // Hide the prev next from sidebarsearch
  if (mode == "sidebarsearch") {
    $jq("#colorbox").find("#overflow-buttons .next, #overflow-buttons .prev").hide()
  }
}

function streamViewPrev(end){
	//Find the type we're dealing with (link- or takeit-)
	if($jq("[id^=link-]").length){
		var s = 'link-';
	}else{
		var s = 'takeit-';
	}
	
	//Find all links
	var prev = $jq("[id^="+s+"]").first().attr("id").replace(s,"");
	$jq("[id^="+s+"]").each(function(index){
		//At end
		if(prev == streamViewCurrent){
			hs_alert(end);
			return false;
		}
		
		//Loop over and find previous link
		if($jq(this).attr("id") == s+streamViewCurrent){
			showOverflow(prev.replace(s,""));
			return false;
		}
		prev = $jq(this).attr("id");
	});
}

function streamViewNext(end){
	//Find the type we're dealing with (link- or takeit-)
	if($jq("[id^=link-]").length){
		var s = 'link-';
	}else{
		var s = 'takeit-';
	}
	
	//Find all links
	var next = $jq("[id^="+s+"]").last().attr("id").replace(s,"");
	$jq($jq("[id^="+s+"]").get().reverse()).each(function(index){
		//At end
		if(next == streamViewCurrent){
			hs_alert(end);
			return false;
		}
		
		//Loop over and find next link
		if($jq(this).attr("id") == s+streamViewCurrent){
			showOverflow(next.replace(s,""));
			return false;
		}
		next = $jq(this).attr("id");
	});
}

//show the note menu
function showNoteItemMenu(){
	if($jq("#"+this.id+" .note-stream-item-menubtn").length){
		$jq("#"+this.id+" .note-stream-item-menubtn").fadeIn("fast");
		
		new Tip(this.id+"-menubtn", $jq("#"+this.id+" .note-stream-item-menu").html(), {
				title: "",
				style: "darkgrey",
				delay: 0,
				showOn: "click",
				hideOn: false,
				hideAfter: 1,
				stem: "topMiddle",
				width: "auto",
				hook: { target: "bottomMiddle", tip: "topMiddle" },
				offset: { x: 0, y: 0 }
			});	
	}
}

function hideNoteItemMenu(){
	if(!$jq(".prototip").is(":visible")) $jq("#"+this.id+" .note-stream-item-menubtn").hide();
}

function ms_select(id,value,fieldname){
	var field = id + "-hidden";
	
	//Set class
	$(id).toggleClassName('select-multiple-selected');
	
	//Insert hidden field
	if(!$(field)){
		$(id).insert({after:'<input type="hidden" id="'+field+'" name="'+fieldname+'[]" value="'+ value + '" />'});
	}else{
		$(field).remove();
	}
}

function ms_select_all(prefix){
	$$("."+prefix+"-select-multiple a").each(function(e){
		if(!$(e.id + "-hidden")){
			e.onclick();
		}
	});
}

function ms_remove_all(prefix){
	$$("."+prefix+"-select-multiple a").each(function(e){
		if($(e.id + "-hidden")){
			e.onclick();
		}
	});
}

function ms_expand(prefix){
	$$("."+prefix+"-select-multiple")[0].setStyle({height:"500px"});
}

function yes_no_btn(type,id,val){
	if(type == "yes"){
		$(id+"-yes").addClassName("btn-selected");
		$(id+"-yes").removeClassName("btn-yes-no");
		$(id+"-no").addClassName("btn-yes-no");
		$(id+"-no").removeClassName("btn-selected");		
	}else{
		$(id+"-no").addClassName("btn-selected");
		$(id+"-no").removeClassName("btn-yes-no");
		$(id+"-yes").addClassName("btn-yes-no");
		$(id+"-yes").removeClassName("btn-selected");		
	}
	
	$(id).setValue(val);
}

function addFolder(def,slist){
	hs_overlay({href:"admin.php?pg=ajax_gateway&action=addfolder&default="+eq(def)+"&folder="+eq(slist),onComplete:function(){$jq("#new_folder").focus();}});
}

function add_folder_action(val,slist){
		foldername = val;
		folders   = $(slist).options;
		folderlen = folders.length;
		newoption = folderlen;

		$(slist).options[newoption]= new Option(foldername,foldername);
		$(slist).selectedIndex = newoption;
		
		$jq.colorbox.close();
}

function ttm_tip(id, txt){
	new Tip(id, txt, {
			title: "",
			style: "darkgrey",
			className: "hstinytip",
			border: 0, 
			radius: 0,
			showOn: "mouseover",
			hideOn: "mouseout",
			stem: "topMiddle",
			width: "auto",
			hook: { target: "bottomMiddle", tip: "topMiddle" }
		});	
}

function ttm_tip_fat(id, txt){
	new Tip(id, txt, {
			title: "",
			style: "darkgrey",
			className: "hstinytip",
			border: 0, 
			radius: 0,
			showOn: "mouseover",
			hideOn: "mouseout",
			stem: "topMiddle",
			width: "160px",
			hook: { target: "bottomMiddle", tip: "topMiddle" }
		});	
}

function showOverflow(reqid, mode){
	Tips.hideAll();

  // Set a flag to hide the prev/next if on the sidebar search.
  if ($jq("#colorbox #rsgroup_1").length === 1) {
    mode = "sidebarsearch"
  }
  
	streamViewInit(reqid, mode);

	//Insert reqid link

	var menubody = new Template('<a href="admin.php?pg=request&reqid=#{id}" id="streamViewReqLink" class="reqid-link" style="display: inline-block;">#{id}</a>');
	$("streamViewTop_reqid").update(menubody.evaluate({id:reqid}));	
	
	var url = "admin.php?pg=request.static&from_streamview=1&reqid=" + reqid + "&rand=" + ajaxRandomString();

	if ($jq("#" + parseInt(reqid) + "_checkbox").is(':checked')) {
		$jq(".js-select-request").addClass("checked");
	} else {
		$jq(".js-select-request").removeClass("checked").prop( "checked", false );
	}
	$jq(".js-select-request").on("click", function(e){
		$jq(".js-select-request").toggleClass("checked");
		$jq("#" + parseInt(reqid) + "_checkbox").trigger("click");
		return false;
	});

	//Do ajax call and update content div
	new Ajax.Updater('streamViewBody',url,{
		evalScripts:true
	});
}

function showHistoryEmailAndHeaders(reqhistid, field, title){
	if(field == "emailheaders"){
		var url = "admin.php?pg=ajax_gateway&action=emailheaders&reqhisid=" + reqhistid + "&rand=" + ajaxRandomString();
	}else{
		var url = "admin.php?pg=ajax_gateway&action=emailsource&reqhisid=" + reqhistid + "&rand=" + ajaxRandomString();
	}
	
	//Show content overlay
	hs_overlay({href:url,title:title});	
}

function simplemenu_action(action, id, mode){
	mode = typeof(mode) != 'undefined' ? mode : "menu";
	
	//Hide tips & quick menu icon
	if(mode != "triage") document.fire("hs_overlay:closed");
	
	//Perform action
	if(action == 'unread'){
		
		$("replied_img_"+id).onclick();
		
		new Effect.Highlight("tr-"+id,{duration:2.0, startcolor:'#ffffff', endcolor:'#ffff99'});
		
	}else if(action == 'trash'){
		
		$("tr-"+id).addClassName("tablerow-trash");
		
		new Ajax.Request(
		'admin.php?pg=ajax_gateway&action=simplemenu_trash', 
		{
			method: 	 "post", 
			parameters:  {reqid:id},
			onComplete: function(r){ 
				if(r.responseText != ""){ 
					hs_alert(r.responseText);  
				}else{
					new Effect.Highlight("tr-"+id,{duration:1.0, startcolor:'#FDDFD7', endcolor:'#D8B3AE', afterFinish:function(){$("tr-"+id).remove();}});
				
					//Move triage to next
					if(mode == "triage") triage_next();					
				}
			}
		});			
		
	}else if(action == 'spam'){
	
		$("tr-"+id).addClassName("tablerow-spam");
		
		new Ajax.Request(
		'admin.php?pg=ajax_gateway&action=simplemenu_spam', 
		{
			method: 	 "post", 
			parameters:  {reqid:id},
			onComplete: function(r){ 
				if(r.responseText != ""){
					hs_alert(r.responseText); 
					$("tr-"+id).removeClassName("tablerow-spam");
				}else{
					new Effect.Highlight("tr-"+id,{duration:1.0, startcolor:'#FDDFD7', endcolor:'#D8B3AE', afterFinish:function(){$("tr-"+id).remove();}});
				
					//Move triage to next
					if(mode == "triage") triage_next();				
				}
			}
		});		
		
	}
}

person_status_update_details_flag=false;
function person_status_update_details(xperson,spage,ftype,sdetails){
	if(!person_status_update_details_flag){
		var pars = "xPersonStatus=" + eq(xperson) + "&sPage=" + eq(spage) + "&fType=" + eq(ftype) + "&sDetails=" + eq(sdetails) + "&rand=" + ajaxRandomString();
		
		var call = new Ajax.Request(
			'admin.php?pg=ajax_gateway&action=person_status_details', 
			{
				method: 	 "post", 
				parameters:  pars
			});	
			
		person_status_update_details_flag = true;
	}
}

function showPersonStatusWorkspace(id,reqid){

	var call = new Ajax.Request(
		'admin.php?pg=ajax_gateway&action=person_status_workspace', 
		{
			method: 	 "get", 
			parameters:  {rand:ajaxRandomString(),reqid:reqid}, 
			onComplete:  function(){ 

							new Tip(id, arguments[0].responseText,{
									title: reqid,
									style: "darkgrey",
									showOn: "click",
                                    hideOn: { element: 'closeButton', event: 'click' },
									hideOthers: true,
									stem: "leftMiddle",
									width: 250,
									hook: { target: "rightMiddle", tip: "leftMiddle" },
									offset: { x: -5, y: 0 }
								});	
								
							$(id).prototip.show();
						 }
		});				
				
}

// Ajax to overlay
function ajax_hs_overlay(elementId, url) {
	$jq.get(url, {}, function(data, status) {
		$jq('#'+elementId).html(data);
		hs_overlay(elementId);
	}, 'html');
}

//Overlay window
function hs_overlay(){
	//Accept 1 arg with just options array or 2 with a body element ID plus options
	if($jq.type(arguments[0]) == "string"){
		var body = arguments[0];
		var options = arguments[1];
	}else{
		var body = false;
		var options = arguments[0];	
	}
	
	var options = Object.extend({
	  width:	false,
	  height:	false,
	  maxWidth:	"90%",
	  maxHeight:"90%",
	  innerWidth: false,
	  innerHeight: false,
	  onHide: 	false,
	  onComplete: false,
	  close: button_close,
	  href: false,
	  iframe: false,
	  html: (body ? $jq("#"+body).html() : false),
	  title:	""
	}, options || { });

	Tips.hideAll();	

	$jq.colorbox({title: options.title,
				  width: (options.innerWidth ? false : options.width),
				  height: (options.innerHeight ? false : options.height),
				  minWidth: "550", //3.0.5 added patched version of colorbox which supports this
				  maxWidth: options.maxWidth,
				  maxHeight: options.maxHeight,
				  innerWidth: options.innerWidth,
				  innerHeight: options.innerHeight,				  
				  opacity: 0.80, 
				  close: options.close,
				  href: options.href,
				  html: options.html,
				  iframe: options.iframe,
				  onComplete: options.onComplete,
				  onCleanup: options.onHide});
				  
	return false;	
}

function insertTemplates(tpl){
	//text
	if($("ta_"+tpl)) $(tpl).value = $F("ta_"+tpl);
	
	//html
	if($("ta_"+tpl+"_html")) $(tpl+"_html").value = $F("ta_"+tpl+"_html");
	if($("ta_"+tpl+"_HTML")) $(tpl+"_HTML").value = $F("ta_"+tpl+"_HTML"); //AUTO RESPONSE TEMPLATE
	
	//subject
	if($("ta_"+tpl+"_subject")) $(tpl+"_subject").value = $F("ta_"+tpl+"_subject");

	//Show save message
	$(tpl+"_savemsg").show();

	$jq.colorbox.close();
}

function rsQuickMenu(elem,reqid){
	var menubody = new Template($("menubtn_tmpl").innerHTML);
	var html = menubody.evaluate({id:reqid});				

	new Tip(elem, html, {
			title: "",
			style: "darkgrey",
			delay: 0,
			showOn: "click",
			hideOn: false,
			hideAfter: 1,
			stem: "topMiddle",
			width: "auto",
			hook: { target: "bottomMiddle", tip: "topMiddle" },
			offset: { x: 0, y: 0 }
		});		
}

function hs_hover(element,newclass){
	if(Element.hasClassName(element,newclass)){
		//Swap to old class
		Element.removeClassName(element,newclass);
	}else{
		//Swap to new class
		Element.addClassName(element,newclass);		
	}
}

function getElementPosition(elemID) {
    var offsetTrail = document.getElementById(elemID);
    var offsetLeft = 0;
    var offsetTop = 0;
    while (offsetTrail) {
        offsetLeft += offsetTrail.offsetLeft;
        offsetTop += offsetTrail.offsetTop;
        offsetTrail = offsetTrail.offsetParent;
    }
    if (navigator.userAgent.indexOf("Mac") != -1 && 
        typeof document.body.leftMargin != "undefined") {
        offsetLeft += document.body.leftMargin;
        offsetTop += document.body.topMargin;
    }
    return {left:offsetLeft, top:offsetTop};
}

function innerWinSize() {
  var myWidth = 0, myHeight = 0;
  if( typeof( window.innerWidth ) == 'number' ) {
    //Non-IE
    myWidth = window.innerWidth;
    myHeight = window.innerHeight;
  } else if( document.documentElement &&
      ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
    //IE 6+ in 'standards compliant mode'
    myWidth = document.documentElement.clientWidth;
    myHeight = document.documentElement.clientHeight;
  } else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
    //IE 4 compatible
    myWidth = document.body.clientWidth;
    myHeight = document.body.clientHeight;
  }
  return {width:myWidth, height:myHeight};
  
}

// Do lookup for ajax custom fields
function custom_ajax_field_lookup(div,url,calling,loading){
	//Get request fields
	query = getRequestFields();
	
	//Adding calling field id
	query.set('callingField', calling);
	
	var pars = "&url=" + eq(url)+ "&" + query.toQueryString() + "&rand=" + ajaxRandomString();
	
	$(div).innerHTML = loading;
	$(div).show();	
	
	var call = new Ajax.Request(
		'admin.php?pg=ajax_gateway&action=ajax_field_lookup', 
		{
			method: 	 "post",
			parameters:  pars, 
			onComplete:  function(){ 
							$(div).innerHTML = arguments[0].responseText;
						 }
		});	
}

//Popup a LL result
function ll_popup(base){
	Tips.hideAll();	

	$jq.colorbox({minWidth: "550",		  
				  opacity: 0.80, 
				  close: button_close,
				  html: $jq(base).next().html()});
}

function ll_popup_move(num,end){
	if($jq('#ll_popup_'+num).length){
		$jq('#ll_popup_'+num).click();
	}else{
		hs_alert(end);
	}
}

// Get field values for all fields on the request page
function getRequestFields(){
	var req = $H();
	
	//Find any requests fields that may be available and send along, if no customer ID present we"re in an automation rule so send back empty
	if($("sUserId")){
		var req = $H({sUserId: eq($F("sUserId")),
				   sFirstName: eq($F("sFirstName")),
				   sLastName: eq($F("sLastName")),
				   sEmail: eq($F("sEmail")),
				   sPhone: eq($F("sPhone")),
				   xStatus: eq($F("xStatus")),
				   xCategory: eq($F("xCategory")),
				   xPersonAssignedTo: eq($F("xPersonAssignedTo"))});
		
		//Check for custom fields and send in available
		var forms = document.getElementsByTagName("form");
		for(i=0;i < forms.length;i++){
			var f = Form.getElements(document.forms[i]);
			for(e=0;e < f.length;e++){
				if(f[e].id.indexOf("Custom") !== -1 && f[e].id.indexOf("_") === -1){ 
					req.set(f[e].id, eq($F(f[e].id)) );
				}
			}
		}
	}
	
	return req;
}

// HELPSPOT SPECIAL EFFECTS
HS_Effects = {	
	RsSetOrder: function(table,sortdiv){
		Element.hide(table);
		Element.show(sortdiv);
	},
	
	RsReturnSetOrder: function(url){
		goPage(url);
	}
};
// HELPSPOT SPECIAL EFFECTS

// AJAX HELPERS
function ajaxError(){

}

function ajaxLoadingImg(){
	return '<img src="'+static_path+'/css/shared/general/big-loader.gif" />';
}

function ajaxLoading(loading){
	return '<div class="inline_loading">'+ajaxLoadingImg()+'</div>';
}

//IE seems to cache ajax calls, this makes the URL unique
function ajaxRandomString(){
	var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
	var string_length = 8;
	var randomstring = '';
	for (var i=0; i<string_length; i++) {
			var rnum = Math.floor(Math.random() * chars.length);
			randomstring += chars.substring(rnum,rnum+1);
	}
	
	return randomstring.toString();
}

//Show spinning thingy for ajax requests
var login_box_active = false;
var ajaxHandlers = {
	onCreate: function(){
		//new Effect.Appear('ajaxFeedback');
	},
	
	onComplete: function(response, transport){
		//if(!Ajax || Ajax.activeRequestCount <= 0){
		//	Element.hide('ajaxFeedback');
		//}
		
		//Handle session timeout
		if(response.getHeader("X-HelpSpot-Session") == "Expired" && !$("colorbox").visible()){
			hs_overlay("login-box", {title:lg_sessionexpired,width: '500px'});
			login_box_active = true;
		}		
	}
};

//Add a selected item from a drop down list to a sortable div list
function addSortableColumn(select_list,sortable_vars,hidden_var,editable,colorselect){
	var listObj = $(select_list);
	
	if(listObj.options){
		if(listObj.selectedIndex != 0){
			var txt = listObj.options[listObj.selectedIndex].text;
			//Sometimes a width value is passed in as well
			if(listObj.options[listObj.selectedIndex].value.indexOf('@@@') !== -1){
				var item = listObj.options[listObj.selectedIndex].value.split('@@@');
				var val = item[0];
				var width = (item[1] ? item[1] : "");
				var hideflow = (item[2] == 'hideflow' ? 'overflowMsg' : 'setColumnWidth');
			}else{
				var val = $F(select_list);
			}		
			var selected = listObj.selectedIndex;
			
			listObj.selectedIndex = 0;
			listObj.options[selected] = null;
		}
	}else{
		var txt = listObj.value;
		var val = eq(listObj.value); //URL encode for placement in hidden field
	}

	var colorid = Math.floor(Math.random() * 2000000000);
	
	var newDiv = Builder.node("div", {id: select_list + "_" + val, className: "sortable_filter", style: "display:none;"}, 
								[Builder.node("img", {src: static_path+"/img/remove2.gif", onClick: "return confirmRemove(\'"+select_list+"_"+val+"\', confirmListDelete);", style: "vertical-align: middle;cursor:pointer;"}),
								" ",
								Builder.node("img", {src: static_path+"/img/drag.gif", className: "drag_handle", style: "vertical-align: middle;cursor:move;"}),
								" ",
								(editable ? Builder.node("img", {src: static_path+"/img/space.gif", width:"16px", height:"16px", style: "vertical-align: middle;cursor:pointer;"}) : ""),
								" - ",
								Builder.node("span", {id: select_list + "_" + val + "_text"}, txt),
								(typeof(width) !== "undefined" ? Builder.node("span", {id: "column_width_" + val, className: "hand filter_width_text", onclick: hideflow+"('column_width_"+val+"');"}, (width !== "" ? width : Builder.node("img", {src:static_path+"/img/fillcol.gif"}))) : "" ),
								(typeof(width) !== "undefined" ? Builder.node("input", {type: "hidden", name: "column_width_" + val + "_value", id: "column_width_" + val + "_value", value: width}) : ""),
								Builder.node("input", {type: "hidden", name: hidden_var, value: val}),
								(typeof(colorselect) !== "undefined" ? Builder.node("input", {"class": "jscolor jscolor-small jscolor-right", "data-jscolor": "{required:false,hash:true}", name: "sListItemsColors[]", value: "", id:colorid}) : ""), //jscolor accepts values in the class attribute
								]
							);
	$(sortable_vars).appendChild(newDiv);
	Effect.Appear(newDiv.id);	

	//Setup JSColor if needed
	if(typeof(colorselect) !== "undefined"){
		var picker = new jscolor(document.getElementById(colorid),{required:false,hash:true,value:null});
	}	
	
	//Destroy original sortable and rebuild with new element
	Sortable.destroy(sortable_vars);
	Sortable.create(sortable_vars ,{tag:"div", constraint: "vertical"});	
}

//Helper for column width JS
function insertColumnWidth(id){
	var value = trim($F(id + "_textbox"));
	
	$(id).update( (value == "" ? "<img src=\""+static_path+"/img/fillcol.gif\" />" : value) );
	$(id + "_value").value = value;
	
	$(id).prototip.remove();
}	

//Fix safari bug where hidden form fields are not sent in reordered order
//Only for use in onsubmit
function safari_order_fix(fieldname, form){
	//Safari only
	if(navigator.appVersion.match(/Konqueror|Safari|KHTML/)){
		
		//Prototype knows correct order of hidden fields so get and create new set of fields
		var inputs = Form.getInputs(form, "hidden", fieldname);
		for(i=0;i<inputs.length;i++){
			new_fields = Builder.node("input", {type: "hidden", name: fieldname, value: inputs[i].value});
			$(form).appendChild(new_fields);
		}			
		
		//Find and remove all hidden form fields
		for(i=0;i<inputs.length;i++){
			Element.remove(inputs[i]);
		}	
	}
	
	return false;
}

//Stop a form entry if a particular form elment is not empty
function stopFormEnter(field){
	if($F(field) == ''){
		return true;
	}else{
		document.getElementById(field).focus();
		return false;	
	}			
}

//Encode string
function eq(string){
	return encodeURIComponent(string);
}

function confirmRemove(id, text){
	return hs_confirm(text,function(){Element.remove(id);});
}

//Insert in text area at cursor position - Copyright Alex King - Licensed LGPL
function insertAtCursor(myField, myValue) {
//IE support
if (document.selection) {
myField.focus();
sel = document.selection.createRange();
sel.text = myValue;
}
//MOZILLA/NETSCAPE support
else if (myField.selectionStart || myField.selectionStart == '0') {
var startPos = myField.selectionStart;
var endPos = myField.selectionEnd;
myField.value = myField.value.substring(0, startPos)
+ myValue
+ myField.value.substring(endPos, myField.value.length);
} else {
myField.value += myValue;
}
}

//Auto grow text areas 
function resize_all_textareas(){
	//If iPhone or iPod Touch then don't resize
	if(!RegExp("iPhone").test(navigator.userAgent) && !RegExp("iPod").test(navigator.userAgent)){
		var textareas=document.getElementsByTagName('textarea');
		for (var i=0;i<textareas.length;i++)
		{	
			//Apply resizing to all areas except the tbody type
			if(textareas[i].id != 'tBody') new ResizeableTextarea(textareas[i]);
		}
	}
}

ResizeableTextarea = Class.create();
ResizeableTextarea.prototype = {
    initialize: function(element, options) {
        this.element = $(element);
        this.size = parseFloat(this.element.getStyle('height') || '100');
        this.options = Object.extend({
            inScreen: true,
            resizeStep: 10,
            minHeight: this.size
        }, options || {});
        Event.observe(this.element, "keyup", this.resize.bindAsEventListener(this));
        if ( !this.options.inScreen ) {
            this.element.style.overflow = 'hidden';
        }
        this.element.setAttribute("wrap","virtual");
        this.resize();
    },
    resize : function(){
        this.shrink();
        this.grow();
    },
    shrink : function(){
        if ( this.size <= this.options.minHeight ){
            return;
        }
        if ( this.element.scrollHeight <= this.element.clientHeight) {
            this.size -= this.options.resizeStep;
            this.element.style.height = this.size+'px';
            this.shrink();
        }
    },
    grow : function(){
        if ( this.element.scrollHeight > this.element.clientHeight ) {
            if ( this.options.inScreen && (20 + this.element.offsetTop + this.element.clientHeight) > document.body.clientHeight ) {
                return;
            }
            this.size += (this.element.scrollHeight - this.element.clientHeight) + this.options.resizeStep;
            this.element.style.height = this.size+'px';
            this.grow();
        }
    }
}

//Cleans the timestamp for date (not datetime) fields
//An identical function is used in the portal helper for date fields
function calendar_clean_date(calendar){
	var id = calendar.params.inputField.id;
	
	//Create javscript date object of selected time
	var odate = new Date($(id).value * 1000);

	//Create a new date starting at midnight
	var ndate = new Date(odate.getFullYear(),odate.getMonth(),odate.getDate(),12,0,0); 

	//Set the modified date back to the ID
	$(id).value = (ndate.getTime()/1000);
}

//Show/hide a date field
function showhide_datefield(rowid){
	if($F(rowid + "_2") == "is" || $F(rowid + "_2") == "less_than" || $F(rowid + "_2") == "greater_than"){
		if($(rowid + "_3")) $(rowid + "_3").show();
		if($("calendar_date_" + rowid)) $("calendar_date_" + rowid).show();
		if($("datepick_" + rowid)) $("datepick_" + rowid).show();	
		if($("datepick_datetime_" + rowid)) $("datepick_datetime_" + rowid).show();	
	}else{
		if($(rowid + "_3")) $(rowid + "_3").hide();
		if($("calendar_date_" + rowid)) $("calendar_date_" + rowid).hide();
		if($("datepick_" + rowid)) $("datepick_" + rowid).hide();	
		if($("datepick_datetime_" + rowid)) $("datepick_datetime_" + rowid).hide();	
	}
}

function showhide_thermostatfield(rowid) {
	console.log('i am called');

	var $row2 = $jq('#' + rowid + "_2");
	var $row3_tf = $jq('#' + rowid + "_3_tf");
	var $row3_sf = $jq('#' + rowid + "_3_sf");

	// Sanity: We need a $row2
	if( $row2.length )
	{
		// If $row2 is a value that should have a textbox, hide the select, show the textbox
		if( $row2.val() == 'is' || $row2.val() == 'less_than' || $row2.val() == 'greater_than' )
		{
			if( $row3_sf.length )
			{
				$row3_sf.hide();
				$row3_sf.attr('name', rowid + '_3_off');
			}

			if( $row3_tf.length )
			{
				$row3_tf.attr('name', rowid + '_3');
				$row3_tf.show();
			}
		} else {
			// If $row2 is a value that should have a select, hide the textbox, show the select
			if( $row3_tf.length )
			{
				$row3_tf.hide();
				$row3_tf.attr('name', rowid + '_3_off');
			}

			if( $row3_sf.length )
			{
				$row3_sf.attr('name', rowid + '_3');
				$row3_sf.show();
			}
		}
	}
}

var calc_row;
function do_min_calc() {
	var min;
	min=$("calc_days").value*60*24;
	min=min+($("calc_hours").value*60);
	$(calc_row).value=min;
}

//Note options table - request and merge request
var note_option_string = '<div id="@tabid"><table cellpadding="0" cellspacing="0" border="0" class="noteoptiontable"><tr class="noteoptionrow"><td class="noteoptiontab" width="145">@tabtext</td><td class="noteoptiontabexp" align="right">@tabexp</td></tr></table><table cellpadding="0" cellspacing="0" border="0" style="margin-bottom:0px;"><tr><td colspan="2" class="noteoptioninner" id="noteoptioninner_@tabid">@bodytext</td></tr></table></div>';

function validate_email(email) {
  // Regex from parsley.js
  var regExp = /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i;
  if ( ! email) {
    return false;
  } else {
    return regExp.test(email);
  }
}

function showViewers(){

    $jq.get('admin.php?pg=ajax_gateway&action=get_request_viewers', function(data){
        var viewers = [];

        // list of all dom ID's with viewers
        $jq.each(data, function(index, value){
            viewers.push('viewing-'+index);
        });

        $jq.each(data, function(index, value){
            $jq("#viewing-"+index)
                .addClass('viewing-'+value.fType)
                .attr('onclick',"showPersonStatusWorkspace('viewing-"+index+"',"+index+");");
        });

        // Remove classes from any that weren't in result set
        $jq(".viewing").each(function(){
            if($jq.inArray(this.id,viewers) == -1){
                $jq(this).removeClass('viewing-2 viewing-1').removeAttr('onclick');
            }
        });
    },"json");
}

$jq(document).ready(function(){
	var checked = ($jq("input.canCheck:checked").length == $jq("input.canCheck").length);
	$jq(".check-all").prop("checked", checked);
	$jq(".check-all").on("change", function(e){
		$jq(".canCheck").prop("checked", $jq(this).prop("checked"));
	});
	$jq(".canCheck").on("change", function(e) {
		var checked = ($jq(".canCheck:checked").length == $jq(".canCheck").length);
		$jq(".check-all").prop("checked", checked);
	});
	$jq(".js-check-all").on("click", function(e){
		var checked = ! ($jq(".canCheck:checked").length == $jq(".canCheck").length);
		$jq(".canCheck").prop("checked", checked);
		return false;
	});
	$jq('.color-label').contrastColor();
});

// Request Pinning
$jq(document).on("click", "a.note-stream-item-pin", function(e){
	var id = $jq(this).data("id");
	$jq.ajax({
		method: "GET",
		url: "admin.php?pg=ajax_gateway&action=request_history_pin",
		data: { "xRequestHistory": id }
	})
		.done(function( msg ) {
			initRequestHistory();
		});
});

$jq.fn.contrastColor = function() {
	return this.each(function() {
		var bg = $jq(this).css('background-color');
		//use first opaque parent bg if element is transparent
		if(bg == 'transparent' || bg == 'rgba(0, 0, 0, 0)') {
			$jq(this).parents().each(function(){
				bg = $jq(this).css('background-color')
				if(bg != 'transparent' && bg != 'rgba(0, 0, 0, 0)') return false;
			});
			//exit if all parents are transparent
			if(bg == 'transparent' || bg == 'rgba(0, 0, 0, 0)') return false;
		}
		//get r,g,b and decide
		var rgb = bg.replace(/^(rgb|rgba)\(/,'').replace(/\)$/,'').replace(/\s/g,'').split(',');
		var yiq = ((rgb[0]*299)+(rgb[1]*587)+(rgb[2]*114))/1000;
		if(yiq >= 128) $jq(this).removeClass('light-color');
		else $jq(this).addClass('light-color');
	});
};

function addSlashes(str)
{
	return str.replace(/'/g, "\\'");
}
function removeSlashes(str)
{
	return str.replace(/\'/g, "'");
}
